-- DataBase

	ScourgeStrikeDB = {
		sct = false;
	}


-- global variables

    SSTemp = 0;
    SSType = 0;
    SSName = "";
    disease = 0;

-- spell ids

    SSiD = 55090;   -- Scourge Strike
    SShiD = 70890;  -- Scourge Strike (Shadow)
    FFiD = 55095;   -- Frost Fever
    SwSiD = 65142;  -- Black Plague
    BSiD = 55078;   -- Blood Plague
    
-- OnLoad

    function ScourgeStrike_OnLoad()
        ScourgeStrikeFrame:RegisterEvent("COMBAT_LOG_EVENT");
        SSName = GetSpellInfo(SSiD);
        print("loaded");
        setglobal("SHOW_COMBAT_TEXT",1);
        LoadAddOn("Blizzard_CombatText");
    end

-- OnEvent

    function ScourgeStrike_OnEvent(event, ...)

        if(event=="COMBAT_LOG_EVENT")then

            -- Return values
            local timestamp, type, hideCaster, sourceGUID, sourceName,
            sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2,
            spellId, spellName, spellSchool,
            amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing = select(1, ...);

            if(sourceName==UnitName("player"))then

                -- check Scourge Strike
                if(type=="SPELL_DAMAGE" and spellId==SSiD)then
                    SSTemp = amount;
                    SSType = critical;

                    disease = 0;
                    for i=1,40 do
                        local name,_,_,_,_,_,_,_,_,_,debuffId= UnitDebuff("target",i,"PLAYER");
                        if name then
                            -- check if diseases are on the target from the player
                            if(debuffId==FFiD or debuffId==SwSiD or debuffId==BSiD)then
                                disease = 1;
                            end
                        end
                    end

                    if(disease==0)then
                        ScourgeStrike_Output(SSTemp, SSType);
                        SSTemp = 0;
                        SSType = 0;
                    end

                end

                -- check Scourge Strike (Shadow)
                if(type=="SPELL_DAMAGE" and spellId==SShiD)then
                    SSTemp = SSTemp + amount;
                    ScourgeStrike_Output(SSTemp, SSType);
                    SSTemp = 0;
                    SSType = 0;
                end

            end
        end
    end
    
-- Output Function

    function ScourgeStrike_Output(dmg, crit)
    	
    	if(ScourgeStrikeDB.sct)then
    	
    		SCT:DisplayCustomEvent(SSName..": "..dmg, {r=0.4,g=0,b=0.8}, crit,SCT.FRAME1);
    	
    	else
            if(crit==1)then
                CombatText_AddMessage(SSName..": "..dmg, CombatText_FountainScroll, 0.4, 0, 0.8, "crit", nil);
            else
                CombatText_AddMessage(SSName..": "..dmg, CombatText_FountainScroll, 0.4, 0, 0.8, "sticky", nil);
            end
    	end
        
    end
    

-- Register chat commands

    SLASH_SS1 = '/ss';

    local function handler(msg, editbox)
    	local command, rest = msg:match("^(%S*)%s*(.-)$");
    	local value = tonumber(rest);
        if command == 'sct' then
        	if (ScourgeStrikeDB.sct) then
        		ScourgeStrikeDB.sct = false;
				print('Output set to BlizzardCombatText!');
        	else
        		ScourgeStrikeDB.sct = true;
        		print('Output set to ScrollingCombatText!');
        	end
        end
    end
    SlashCmdList["SS"] = handler;